<?php
/*------------------------------------------------------------------------
# com_contentfake - Content Fake
# ------------------------------------------------------------------------
# author    Francisco Javier Félix Belmonte
# copyright Copyright (C) 2014 www.inode64.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.inode64.com
# Technical Support:  http://www.inode64.com/Codigo/Joomla/Componente-CONTENT_FAKE-para-la-creacion-de-contenidos-falsos.html
-------------------------------------------------------------------------*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.modelitem');
jimport('joomla.filesystem.file');

class ContentFakeModelContentFake extends JModelItem
{
	protected $item;
	protected $patterns = array('//', '/[\s]+/', '/[\.]+/', '/[\|]+/');
	protected $join_chars = array('', ' ', '.', '|');

	public function getTable($type = 'ContentFake', $prefix = 'ContentFakeTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	public function rgb2array($rgb) {
		return array(
						hexdec(substr($rgb, 0, 2)),
						hexdec(substr($rgb, 2, 2)),
						hexdec(substr($rgb, 4, 2))
		);
	}

	public function create_image($width, $height, $color)
	{

		$md = md5("$width $height $color");
		$file = $this->getImagePath().$md.'.png';

		if (!JFile::exists($file)) {
			$bgcolor = ContentFakeModelContentFake::rgb2array($color);

			$im = ImageCreate($width, $height);
			$bg = ImageColorAllocate($im, $bgcolor[0], $bgcolor[1], $bgcolor[2]);
			$text = $width . 'x' . $height;

			$color4 = ImageColorAllocate($im,255 - $bgcolor[0],255 - $bgcolor[1],255 - $bgcolor[2]);

			$ang = 0;
			$font = $width / 8;
			// determine numeric center of image
			$size = ImageTTFBBox($font,$ang,JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'VeraBd.ttf',$text);
			$X = ($width - (abs($size[2]- $size[0])))/2;
			$Y = (($height - (abs($size[5] - $size[3])))/2 + (abs($size[5] - $size[3])));
			if ( $width < 50 ) {
				if ( $height < 50 ) {
					$ang = 45;
					$font = $width / 6;
					$size = ImageTTFBBox($font,$ang,JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'VeraBd.ttf',$text);
					$X = ($width - $size[4]) / 2;
					$Y = ($height - $size[3]) / 2;
				} elseif ( $height > $width ) {
				    $ang = 90;
				    $font = $height / 16;
				    $size = ImageTTFBBox($font,$ang,JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'VeraBd.ttf',$text);
				    $X = ($width - $size[4]) / 2 + 2;
				    $Y = ($height - $size[3]) / 2;
				}
			}

			//places numeric information on image
			ImageTTFText($im,$font,$ang,($X-1),$Y,$color4,JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'VeraBd.ttf',$text);
			ImagePNG($im, $file);
		}

		return JURI::root().'media/contentfake/images/'.$md.'.png';
	}

	public function fillArray( $elements, $n){
		$size = count($elements);
		$to_go = $n - $size;

		$newElements = array();
		for( $i = 0; $i < $to_go; $i++)
			array_push($newElements, $elements[ $i % $size ]);

		return array_merge($elements, $newElements);
	}

	public function check_index($index,$count_array){
		return ($index >= $count_array) ? 0 : $index;
	}

	public function getImagePath(){
		return JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'images'.DIRECTORY_SEPARATOR;
	}

	public function getTextPosition($type){
		$style = array('left', 'right', 'center', 'justify', 'none');
		return (isset($style[$type])) ? $style[$type] : '';
	}

	public function getImagePosition( $type ){
		$style = array('none', 'left', 'right');
		return (isset($style[$type])) ? $style[$type] : '';
	}

	public function toParagraph( $text, $type ){
		$result  = '';
		switch ($type){
			case 2:
				$result = $text . '<br>';
				break;
			case 1:
				$result = '<div>' . $text . '</div>';
				break;
			default:
			case 0:
				$result = '<p>' . $text . '</p>';
				break;
		}
		return $result;
	}

	public function getMsg()
	{
		if (!isset($this->item))
		{
			$this->item = new stdClass();

			$id = JRequest::getInt('id');
			$type = JRequest::getInt('mode');
			$count = JRequest::getInt('count');
			$textalign = JRequest::getInt('textalign');

			$table = $this->getTable();
			$table->load($id);

			$width = JRequest::getInt('width');
			$height = JRequest::getInt('height');
			$color = JRequest::getString('imagebgcolor');

			$style = $this->getTextPosition(JRequest::getInt('textposition') );
			//Image
			$this->item->imageposition = $this->getImagePosition( JRequest::getInt('imageposition') );
			$this->item->alt  = $width . 'x' . $height;
			$this->item->imagemargin = JRequest::getString('imagemargin');
			$this->item->customimage = JRequest::getString('pickpica');
			$this->item->size = ($width>0) ? " width: " . $width . "px;" : "";
			$this->item->size .= ($height>0) ? " height: " . $height . "px;" : "";

			if (empty($this->item->customimage)) {
				$this->item->image = $this->create_image($width, $height, $color);
			}

			$repeat = 0;
			$this->item->text = '';
			//Text
			if ($style != 'none' ) {
				$text = explode("|", $table->content);

				for($i=0; $i<$count; $i++)
				{
					$this->item->text .= $this->toParagraph($text[$i], $type);
					if ($i==count($text)-1) {
						$i = -1;
						$count -= count($text)-1;
					}
				}

				$this->item->text = "<div style='text-align:$style'>" . $this->item->text . "</div>";
			}
		}
		return $this->item;
	}
}
?>